searchNodes=[{"doc":"An OpenTelemetry Trace consists of 1 or more Spans that either have a parent/child relationship or are linked together through a Link. Each Span has a TraceId (trace_id/0), SpanId (span_id/0), and a start and end time in nanoseconds. This module provides declaration of the types used throughout the library, as well as functions for building the additional pieces of a span that are optional. Each item can be attached to individual Span using the functions in OpenTelemetry.Span module. Example require OpenTelemetry.Tracer require OpenTelemetry.Span OpenTelemetry.register_application_tracer(:this_otp_app) Tracer.start_span(&quot;some-span&quot;) ... ecto_event = OpenTelemetry.event(&quot;ecto.query&quot;, [{&quot;query&quot;, query}, {&quot;total_time&quot;, total_time}]) OpenTelemetry.Span.add_event(ecto_event) ... Tracer.end_span()","ref":"OpenTelemetry.html","title":"OpenTelemetry","type":"module"},{"doc":"Creates a event/0.","ref":"OpenTelemetry.html#event/2","title":"OpenTelemetry.event/2","type":"function"},{"doc":"Creates a event/0.","ref":"OpenTelemetry.html#event/3","title":"OpenTelemetry.event/3","type":"function"},{"doc":"Creates a list of event/0 items.","ref":"OpenTelemetry.html#events/1","title":"OpenTelemetry.events/1","type":"function"},{"doc":"Creates a link/0.","ref":"OpenTelemetry.html#link/4","title":"OpenTelemetry.link/4","type":"function"},{"doc":"Creates a list of link/0 from a list of 3-tuples.","ref":"OpenTelemetry.html#links/1","title":"OpenTelemetry.links/1","type":"function"},{"doc":"See :opentelemetry.register_application_meter/1.","ref":"OpenTelemetry.html#register_application_meter/1","title":"OpenTelemetry.register_application_meter/1","type":"function"},{"doc":"Current time in UNIX Epoch time, nanoseconds since 00:00:00 UTC on 1 January 1970.","ref":"OpenTelemetry.html#register_application_tracer/1","title":"OpenTelemetry.register_application_tracer/1","type":"function"},{"doc":"Creates a Status.","ref":"OpenTelemetry.html#status/2","title":"OpenTelemetry.status/2","type":"function"},{"doc":"See :opentelemetry.timestamp/0.","ref":"OpenTelemetry.html#timestamp/0","title":"OpenTelemetry.timestamp/0","type":"function"},{"doc":"","ref":"OpenTelemetry.html#t:attribute_key/0","title":"OpenTelemetry.attribute_key/0","type":"type"},{"doc":"","ref":"OpenTelemetry.html#t:attribute_value/0","title":"OpenTelemetry.attribute_value/0","type":"type"},{"doc":"Attributes are a collection of key/value pairs. The value can be a string, an integer, a double or the boolean values true or false. Note, global attributes like server name can be set using the resource API. Examples of attributes: [{&quot;/http/user_agent&quot; &quot;Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36&quot;} {&quot;/http/server_latency&quot;, 300} {&quot;abc.com/myattribute&quot;, True} {&quot;abc.com/score&quot;, 10.239}]","ref":"OpenTelemetry.html#t:attributes/0","title":"OpenTelemetry.attributes/0","type":"type"},{"doc":"An Event is a time-stamped annotation of the span, consisting of user-supplied text description and key-value pairs.","ref":"OpenTelemetry.html#t:event/0","title":"OpenTelemetry.event/0","type":"type"},{"doc":"A Link is a pointer from the current span to another span in the same trace or in a different trace. For example, this can be used in batching operations, where a single batch handler processes multiple requests from different traces or when the handler receives a request from a different project.","ref":"OpenTelemetry.html#t:link/0","title":"OpenTelemetry.link/0","type":"type"},{"doc":"Span represents a single operation within a trace. Spans can be nested to form a trace tree. Spans may also be linked to other spans from the same or different trace and form graphs. Often, a trace contains a root span that describes the end-to-end latency, and one or more subspans for its sub-operations. A trace can also contain multiple root spans, or none at all. Spans do not need to be contiguous - there may be gaps or overlaps between spans in a trace.","ref":"OpenTelemetry.html#t:span/0","title":"OpenTelemetry.span/0","type":"type"},{"doc":"A SpanContext represents the portion of a Span which must be as well as being serialized and propagated along side of a distributed context.","ref":"OpenTelemetry.html#t:span_ctx/0","title":"OpenTelemetry.span_ctx/0","type":"type"},{"doc":"SpanId is a unique identifier for a span within a trace, assigned when the span is created. The ID is an 8-byte array. An ID with all zeroes is considered invalid.","ref":"OpenTelemetry.html#t:span_id/0","title":"OpenTelemetry.span_id/0","type":"type"},{"doc":"An optional final status for this span. Semantically when Status wasn't set it means span ended without errors and assume Ok.","ref":"OpenTelemetry.html#t:status/0","title":"OpenTelemetry.status/0","type":"type"},{"doc":"TraceId is a unique identifier for a trace. All spans from the same trace share the same trace_id. The ID is a 16-byte array. An ID with all zeroes is considered invalid.","ref":"OpenTelemetry.html#t:trace_id/0","title":"OpenTelemetry.trace_id/0","type":"type"},{"doc":"Tracestate represents tracing-system specific context in a list of key-value pairs. Tracestate allows different vendors propagate additional information and inter-operate with their legacy Id formats. It is a tracestate in the w3c-trace-context format. See also https://github.com/w3c/distributed-tracing for more details about this field.","ref":"OpenTelemetry.html#t:tracestate/0","title":"OpenTelemetry.tracestate/0","type":"type"},{"doc":"require OpenTelemetry.Counter OpenTelemetry.Counter.add(&quot;some.counter&quot;, 3)","ref":"OpenTelemetry.Counter.html","title":"OpenTelemetry.Counter","type":"module"},{"doc":"","ref":"OpenTelemetry.Counter.html#add/2","title":"OpenTelemetry.Counter.add/2","type":"macro"},{"doc":"","ref":"OpenTelemetry.Counter.html#add/3","title":"OpenTelemetry.Counter.add/3","type":"macro"},{"doc":"See :ot_counter.measurement/2.","ref":"OpenTelemetry.Counter.html#measurement/2","title":"OpenTelemetry.Counter.measurement/2","type":"function"},{"doc":"require OpenTelemetry.Measure OpenTelemetry.Measure.record(&quot;some.counter&quot;, 3)","ref":"OpenTelemetry.Measure.html","title":"OpenTelemetry.Measure","type":"module"},{"doc":"See :ot_measure.measurement/2.","ref":"OpenTelemetry.Measure.html#measurement/2","title":"OpenTelemetry.Measure.measurement/2","type":"function"},{"doc":"","ref":"OpenTelemetry.Measure.html#record/2","title":"OpenTelemetry.Measure.record/2","type":"macro"},{"doc":"","ref":"OpenTelemetry.Measure.html#record/3","title":"OpenTelemetry.Measure.record/3","type":"macro"},{"doc":"require OpenTelemetry.Meter OpenTelemetry.register_application_meter(Your.Application) OpenTelemetry.Meter.new_instruments([...]) bound = OpenTelemetry.Meter.bind(&quot;some.latency&quot;, []) # measure time spent on some function and then record it OpenTelemetry.Meter.record(bound, time)","ref":"OpenTelemetry.Meter.html","title":"OpenTelemetry.Meter","type":"module"},{"doc":"","ref":"OpenTelemetry.Meter.html#bind/2","title":"OpenTelemetry.Meter.bind/2","type":"macro"},{"doc":"","ref":"OpenTelemetry.Meter.html#new_instruments/1","title":"OpenTelemetry.Meter.new_instruments/1","type":"macro"},{"doc":"","ref":"OpenTelemetry.Meter.html#record/2","title":"OpenTelemetry.Meter.record/2","type":"macro"},{"doc":"","ref":"OpenTelemetry.Meter.html#record/3","title":"OpenTelemetry.Meter.record/3","type":"macro"},{"doc":"","ref":"OpenTelemetry.Meter.html#record_batch/2","title":"OpenTelemetry.Meter.record_batch/2","type":"macro"},{"doc":"","ref":"OpenTelemetry.Meter.html#release/1","title":"OpenTelemetry.Meter.release/1","type":"macro"},{"doc":"require OpenTelemetry.Observer OpenTelemetry.Observer.set_callback(&quot;some.counter&quot;, fn o -&gt; OpenTelemetry.Observer.observe(o, 33, []))","ref":"OpenTelemetry.Observer.html","title":"OpenTelemetry.Observer","type":"module"},{"doc":"See :ot_observer.observe/3.","ref":"OpenTelemetry.Observer.html#observe/3","title":"OpenTelemetry.Observer.observe/3","type":"function"},{"doc":"","ref":"OpenTelemetry.Observer.html#set_callback/2","title":"OpenTelemetry.Observer.set_callback/2","type":"macro"},{"doc":"This module contains macros for Span operations that update the active current Span in the current process. An example of creating an Event and adding it to the current Span: require OpenTelemetry.Span ... ecto_event = OpenTelemetry.event(&quot;ecto.query&quot;, [{&quot;query&quot;, query}, {&quot;total_time&quot;, total_time}]) OpenTelemetry.Span.add_event(ecto_event) ... A Span represents a single operation within a trace. Spans can be nested to form a trace tree. Each trace contains a root span, which typically describes the end-to-end latency and, optionally, one or more sub-spans for its sub-operations. Spans encapsulate: The span name An immutable SpanContext (OpenTelemetry.span_ctx/0) that uniquely identifies the Span A parent Span in the form of a Span (OpenTelemetry.span/0), SpanContext (OpenTelemetry.span_ctx/0), or undefined A start timestamp An end timestamp An ordered mapping of Attributes (OpenTelemetry.attributes/0) A list of Links to other Spans (OpenTelemetry.link/0) A list of timestamped Events (OpenTelemetry.event/0) A Status (OpenTelemetry.status/0)","ref":"OpenTelemetry.Span.html","title":"OpenTelemetry.Span","type":"module"},{"doc":"Add an event to the currently active Span.","ref":"OpenTelemetry.Span.html#add_event/1","title":"OpenTelemetry.Span.add_event/1","type":"macro"},{"doc":"Add a list of events to the currently active Span.","ref":"OpenTelemetry.Span.html#add_events/1","title":"OpenTelemetry.Span.add_events/1","type":"macro"},{"doc":"Set an attribute with key and value on the currently active Span.","ref":"OpenTelemetry.Span.html#set_attribute/2","title":"OpenTelemetry.Span.set_attribute/2","type":"macro"},{"doc":"Add a list of attributes to the currently active Span.","ref":"OpenTelemetry.Span.html#set_attributes/1","title":"OpenTelemetry.Span.set_attributes/1","type":"macro"},{"doc":"Sets the Status of the currently active Span. If used, this will override the default Span Status, which is Ok.","ref":"OpenTelemetry.Span.html#set_status/1","title":"OpenTelemetry.Span.set_status/1","type":"macro"},{"doc":"Updates the Span name. It is highly discouraged to update the name of a Span after its creation. Span name is often used to group, filter and identify the logical groups of spans. And often, filtering logic will be implemented before the Span creation for performance reasons. Thus the name update may interfere with this logic. The function name is called UpdateName to differentiate this function from the regular property setter. It emphasizes that this operation signifies a major change for a Span and may lead to re-calculation of sampling or filtering decisions made previously depending on the implementation.","ref":"OpenTelemetry.Span.html#update_name/1","title":"OpenTelemetry.Span.update_name/1","type":"macro"},{"doc":"This module contains macros for Tracer operations around the lifecycle of the Spans within a Trace. The Tracer is able to start a new Span as a child of the active Span of the current process, set a different Span to be the current Span by passing the Span's context, end a Span or run a code block within the context of a newly started span that is ended when the code block completes. The macros use the Tracer registered to the Application the module using the macro is included in, assuming OpenTelemetry.register_application_tracer/1 has been called for the Application. If not then the default Tracer is used. require OpenTelemetry.Tracer OpenTelemetry.Tracer.with_span &quot;span-1&quot; do ... do something ... end","ref":"OpenTelemetry.Tracer.html","title":"OpenTelemetry.Tracer","type":"module"},{"doc":"Returns the currently active OpenTelemetry.tracer_ctx/0.","ref":"OpenTelemetry.Tracer.html#current_ctx/0","title":"OpenTelemetry.Tracer.current_ctx/0","type":"macro"},{"doc":"Returns the currently active OpenTelemetry.span_ctx/0.","ref":"OpenTelemetry.Tracer.html#current_span_ctx/0","title":"OpenTelemetry.Tracer.current_span_ctx/0","type":"macro"},{"doc":"End the Span. Sets the end timestamp for the currently active Span. This has no effect on any child Spans that may exist of this Span. The default Tracer in the OpenTelemetry Erlang/Elixir SDK will then set the parent, if there is a local parent of the current Span, to the current active Span.","ref":"OpenTelemetry.Tracer.html#end_span/0","title":"OpenTelemetry.Tracer.end_span/0","type":"macro"},{"doc":"Takes a OpenTelemetry.span_ctx/0 and the Tracer sets it to the currently active Span.","ref":"OpenTelemetry.Tracer.html#set_span/1","title":"OpenTelemetry.Tracer.set_span/1","type":"macro"},{"doc":"Creates a new span and makes it the current active span of the current process. The current active Span is used as the parent of the created Span unless a parent is given in the start_opts/0 argument or there is no active Span. If there is neither a current Span or a parent option given then the Tracer checks for an extracted SpanContext to use as the parent. If there is also no extracted context then the created Span is a root Span.","ref":"OpenTelemetry.Tracer.html#start_span/2","title":"OpenTelemetry.Tracer.start_span/2","type":"macro"},{"doc":"Creates a new span which is ended automatically when the block completes. See start_span/2 and end_span/0.","ref":"OpenTelemetry.Tracer.html#with_span/3","title":"OpenTelemetry.Tracer.with_span/3","type":"macro"},{"doc":"","ref":"OpenTelemetry.Tracer.html#t:start_opts/0","title":"OpenTelemetry.Tracer.start_opts/0","type":"type"},{"doc":"Erlang/Elixir OpenTelemetry API This is the API portion of OpenTelemetry for Erlang and Elixir Applications. This is a library, it does not start any processes, and should be the only OpenTelemetry dependency of Erlang/Elixir Applications. The end user of your Application can then choose to include the OpenTelemetry implementation Application. If the implementation Application is not in the final release the OpenTelemetry instrumentation will all be no-ops. This means no processes started, no ETS tables created and nothing added to the process dictionary. This separation is done so you should feel comfortable instrumenting your Erlang/Elixir Application with OpenTelemetry and not worry that a complicated dependency is being forced on your users.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"When instrumenting an Application to be used as a dependency of other projects it is best practice to register a Tracer with a name and a version using the Application's name and version. This should be the name and version of the Application that has the opentelemetry calls being written in it, not the name of the Application it might be being used to instrument. For example, an Elli middleware to add tracing to the Elli HTTP server would not be named elli, it would be the name of the middleware Application, like opentelemetry_elli. Registration is done through a single process and uses a persistent_term, so should be done only once per-Application. Updating a registration is allowed, so updating the version on a release upgrade can, and should, be done, but will involve the performance penalty of updating a persistent_term. Naming the Tracers provides additional metadata on spans and allows the user of your Application to disable the traces from the dependency if it is needed. Registering and Using Tracers Directly If it is a runnable application then this registration should happen in start/2, example below is adding Tracer registration to the Postgres library pgo: start(_StartType, _StartArgs) -&gt; _ = opentelemetry:register_application_tracer(pgo), ... Or for an Elixir Application named MyApp: defmodule MyApp do use Application def start(_type, _args) do _ = OpenTelemetry.register_application_tracer(MyApp), ... end end Then when the spans are started and finished in the application's code the Tracer is fetched with get_tracer/1 and passed to with_span/3 or start_span/3: Tracer = opentelemetry:get_tracer(pgo), ot_tracer:with_span(Tracer, &lt;&lt;&quot;pgo:query/3&quot;&gt;&gt;, fun() -&gt; ... end). A Tracer variable can be passed through your Application's calls so get_tracer only has to be called once, it is safe to store it in the state of a gen_server and to pass across process boundaries. If the application does not have a start/2 there may be another function that is always called before the library would create any spans. For example, the Elli middleware for OpenTelemetry instrumentation registers the Tracer during Elli startup: handle_event(elli_startup, _Args, _Config) -&gt; _ = opentelemetry:register_application_tracer(opentelemetry_elli), ok; When there is no startup of any kind to hook into in the library itself it should export a function register_application_tracer/0 to be used by any application that depends on it to do the registration: -module(mylib). -export([register_tracer/0]). register_tracer() -&gt; _ = opentelemetry:register_application_tracer(mylib), ok. Not registering does not cause any issues or crashes, OpenTelemetry simply will fallback to the default Tracer if get_tracer/1 is called with a name that is not registered. Helper Macros for Application Tracers When register_application_tracer/1 is used to register a Tracer there are both Erlang and Elixir macros that make use of the current module's name to lookup the Tracer for you and can be used for Trace and Span operations: -include_lib(&quot;opentelemetry_api/include/tracer.hrl&quot;). some_fun() -&gt; ?with_span(&lt;&lt;&quot;some_fun/0&quot;&gt;&gt;, \#{}, fun(_SpanCtx) -&gt; ... ?add_attribute(&lt;&lt;&quot;key&quot;&gt;&gt;, &lt;&lt;&quot;value&quot;&gt;&gt;), ... end), require OpenTelemetry.Tracer require OpenTelemetry.Span def some_fun() do OpenTelemetry.Tracer.with_span \\&quot;some-span\\&quot; do ... OpenTelemetry.Span.add_attribute(&quot;key&quot;, &quot;value&quot;) ... end end Including the OpenTelemetry SDK For traces to actually be tracked, propagated and exported, the opentelemetry Application must be included as a dependency of your project, likely as part of a Release and not as a dependency of an individual Application within the Release. See the Using section of the OpenTelemetry-Erlang repository for details. Exporting Spans Exporters can be found as separate Applications on Github under the OpenTelemetry Beam Organization. Zipkin","ref":"readme.html#use","title":"Overview - Use","type":"extras"},{"doc":"See the contributing file.","ref":"readme.html#contributing","title":"Overview - Contributing","type":"extras"},{"doc":"Module opentelemetry Description Data Types Function Index Function Details The types defined here, and referencing records in opentelemetry.hrl are used to store trace information while being collected on the Erlang node.","ref":"opentelemetry.html","title":"opentelemetry","type":"extras"},{"doc":"Thus, while the types are based on protos found in the opentelemetry-proto repo: src/opentelemetry/proto/trace/v1/trace.proto, they are not exact translations because further processing is done after the span has finished and can be vendor specific. For example, there is no count of the number of dropped attributes in the span record. And an attribute's value can be a function to only evaluate the value if it is actually used (at the time of exporting). And the stacktrace is a regular Erlang stack trace.","ref":"opentelemetry.html#description","title":"opentelemetry - Description","type":"extras"},{"doc":"attribute() attribute() = {unicode:unicode_binary(), attribute_value()} attribute_key() attribute_key() = unicode:unicode_binary() attribute_value() attribute_value() = any() attributes() attributes() = [attribute()] event() event() = #event{system_time_nano = non_neg_integer(), name = unicode:unicode_binary(), attributes = opentelemetry:attributes()} events() events() = [#event{system_time_nano = non_neg_integer(), name = unicode:unicode_binary(), attributes = opentelemetry:attributes()}] http_headers() http_headers() = [{unicode:unicode_binary(), unicode:unicode_binary()}] link() link() = #link{trace_id = opentelemetry:trace_id(), span_id = opentelemetry:span_id(), attributes = opentelemetry:attributes(), tracestate = opentelemetry:tracestate()} links() links() = [#link{trace_id = opentelemetry:trace_id(), span_id = opentelemetry:span_id(), attributes = opentelemetry:attributes(), tracestate = opentelemetry:tracestate()}] meter() meter() = {module(), term()} resource() resource() = \#{unicode:unicode_binary() =&gt; unicode:unicode_binary()} span() span() = term() span_ctx() span_ctx() = #span_ctx{trace_id = opentelemetry:trace_id() | undefined, span_id = opentelemetry:span_id() | undefined, trace_flags = integer() | undefined, tracestate = opentelemetry:tracestate() | undefined, is_valid = boolean() | undefined, is_remote = boolean() | undefined, is_recording = boolean() | undefined} span_id() span_id() = non_neg_integer() span_kind() span_kind() = SPAN_KIND_UNSPECIFIED | INTERNAL | SERVER | CLIENT | PRODUCER | CONSUMER span_name() span_name() = unicode:unicode_binary() stack_trace() stack_trace() = [erlang:stack_item()] status() status() = #status{code = atom() | integer(), message = unicode:unicode_binary()} timestamp() timestamp() = integer() trace_id() trace_id() = non_neg_integer() tracer() tracer() = {module(), term()} tracestate() tracestate() = [{unicode:latin1_chardata(), unicode:latin1_chardata()}]","ref":"opentelemetry.html#data-types","title":"opentelemetry - Data Types","type":"extras"},{"doc":"convert_timestamp/2event/2event/3events/1generate_span_id/0 Generates a 64 bit random integer to use as a span id.generate_trace_id/0 Generates a 128 bit random integer to use as a trace id.get_context_manager/0get_http_extractor/0get_http_injector/0get_meter/0get_meter/1get_tracer/0get_tracer/1link/4links/1register_application_meter/1register_application_tracer/1register_meter/2register_tracer/2set_default_context_manager/1set_default_meter/1set_default_tracer/1set_http_extractor/1set_http_injector/1set_meter/2set_tracer/2status/2timestamp/0timestamp_to_nano/1","ref":"opentelemetry.html#function-index","title":"opentelemetry - Function Index","type":"extras"},{"doc":"convert_timestamp/2 convert_timestamp(Timestamp::timestamp(), Unit::erlang:time_unit()) -&gt; integer() event/2 event(Name, Attributes) -&gt; event() | undefined Name = unicode:unicode_binary()Attributes = attributes() event/3 event(Timestamp, Name, Attributes) -&gt; event() | undefined Timestamp = non_neg_integer()Name = unicode:unicode_binary()Attributes = attributes() events/1 events(List) -&gt; any() generate_span_id/0 generate_span_id() -&gt; span_id() Generates a 64 bit random integer to use as a span id. generate_trace_id/0 generate_trace_id() -&gt; trace_id() Generates a 128 bit random integer to use as a trace id. get_context_manager/0 get_context_manager() -&gt; ot_ctx:context_manager() get_http_extractor/0 get_http_extractor() -&gt; any() get_http_injector/0 get_http_injector() -&gt; any() get_meter/0 get_meter() -&gt; meter() get_meter/1 get_meter(Name::atom()) -&gt; meter() get_tracer/0 get_tracer() -&gt; tracer() get_tracer/1 get_tracer(Name::atom()) -&gt; tracer() link/4 link(TraceId, SpanId, Attributes, TraceState) -&gt; link() | undefined TraceId = trace_id()SpanId = span_id()Attributes = attributes()TraceState = tracestate() links/1 links(List::[{TraceId, SpanId, Attributes, TraceState}]) -&gt; links() TraceId = trace_id()SpanId = span_id()Attributes = attributes()TraceState = tracestate() register_application_meter/1 register_application_meter(Name::atom()) -&gt; boolean() register_application_tracer/1 register_application_tracer(Name::atom()) -&gt; boolean() register_meter/2 register_meter(Name::atom(), Vsn::string()) -&gt; boolean() register_tracer/2 register_tracer(Name::atom(), Vsn::string()) -&gt; boolean() set_default_context_manager/1 set_default_context_manager(ContextManager::ot_ctx:context_manager()) -&gt; boolean() set_default_meter/1 set_default_meter(Meter::meter()) -&gt; boolean() set_default_tracer/1 set_default_tracer(Tracer::tracer()) -&gt; boolean() set_http_extractor/1 set_http_extractor(List) -&gt; any() set_http_injector/1 set_http_injector(List) -&gt; any() set_meter/2 set_meter(Name::atom(), Meter::meter()) -&gt; boolean() set_tracer/2 set_tracer(Name::atom(), Tracer::tracer()) -&gt; boolean() status/2 status(Code, Message) -&gt; status() | undefined Code = atom()Message = unicode:unicode_binary() timestamp/0 timestamp() -&gt; integer() timestamp_to_nano/1 timestamp_to_nano(Timestamp::timestamp()) -&gt; integer()","ref":"opentelemetry.html#function-details","title":"opentelemetry - Function Details","type":"extras"},{"doc":"Module ot_correlations Data Types Function Index Function Details","ref":"ot_correlations.html","title":"ot_correlations","type":"extras"},{"doc":"hop_limit() hop_limit() = no_propagation | unlimited_propagation key() key() = string() value() value() = string()","ref":"ot_correlations.html#data-types","title":"ot_correlations - Data Types","type":"extras"},{"doc":"ctx_key/0get_http_propagators/0set/3","ref":"ot_correlations.html#function-index","title":"ot_correlations - Function Index","type":"extras"},{"doc":"ctx_key/0 ctx_key() -&gt; any() get_http_propagators/0 get_http_propagators() -&gt; {ot_propagation:http_extractor(), ot_propagation:http_injector()} set/3 set(Key::key(), Value::value(), HopLimit::hop_limit()) -&gt; ok","ref":"ot_correlations.html#function-details","title":"ot_correlations - Function Details","type":"extras"},{"doc":"Module ot_counter Function Index Function Details","ref":"ot_counter.html","title":"ot_counter","type":"extras"},{"doc":"add/2add/4measurement/2","ref":"ot_counter.html#function-index","title":"ot_counter - Function Index","type":"extras"},{"doc":"add/2 add(BoundInstrument::ot_meter:bound_instrument(), Number::number()) -&gt; ok add/4 add(Meter::opentelemetry:meter(), Name::ot_meter:name(), Number::number(), LabelSet::ot_meter:label_set()) -&gt; ok measurement/2 measurement(NameOrInstrument::ot_meter:bound_instrument() | ot_meter:name(), Number::number()) -&gt; {ot_meter:bound_instrument() | ot_meter:name(), number()}","ref":"ot_counter.html#function-details","title":"ot_counter - Function Details","type":"extras"},{"doc":"Module ot_ctx Data Types Function Index Function Details This module defines the ot_ctx behaviour. Required callback functions: set_value/4, get_value/3, get_value/4, remove/3, clear/2, set_current/3, get_current/2.","ref":"ot_ctx.html","title":"ot_ctx","type":"extras"},{"doc":"context_manager() context_manager() = {module(), term()} ctx() ctx() = map() key() key() = term() namespace() namespace() = term() value() value() = term()","ref":"ot_ctx.html#data-types","title":"ot_ctx - Data Types","type":"extras"},{"doc":"clear/1get_current/1get_value/2get_value/3http_extractor/2http_extractor/3http_extractor_fun/4http_extractor_fun/5http_injector/2http_injector/3http_injector_fun/4http_injector_fun/5remove/2set_current/2set_value/3","ref":"ot_ctx.html#function-index","title":"ot_ctx - Function Index","type":"extras"},{"doc":"clear/1 clear(Namespace::namespace()) -&gt; ok get_current/1 get_current(Namespace::namespace()) -&gt; ctx() get_value/2 get_value(Namespace::namespace(), Key::key()) -&gt; value() | undefined get_value/3 get_value(Namespace::namespace(), Key::key(), Default::value()) -&gt; value() http_extractor/2 http_extractor(Namespace, FromText) -&gt; any() http_extractor/3 http_extractor(Namespace, Key, FromText) -&gt; any() http_extractor_fun/4 http_extractor_fun(Headers, ContextManager, Namespace, FromText) -&gt; any() http_extractor_fun/5 http_extractor_fun(Headers, ContextManager, Namespace, Key, FromText) -&gt; any() http_injector/2 http_injector(Namespace, ToText) -&gt; any() http_injector/3 http_injector(Namespace, Key, ToText) -&gt; any() http_injector_fun/4 http_injector_fun(Headers, ContextManager, Namespace, ToText) -&gt; any() http_injector_fun/5 http_injector_fun(Headers, ContextManager, Namespace, Key, ToText) -&gt; any() remove/2 remove(Namespace::namespace(), Key::key()) -&gt; ok set_current/2 set_current(Namespace::namespace(), Ctx::ctx()) -&gt; ok set_value/3 set_value(Namespace::namespace(), Key::key(), Value::value()) -&gt; ok","ref":"ot_ctx.html#function-details","title":"ot_ctx - Function Details","type":"extras"},{"doc":"Module ot_ctx_noop Function Index Function Details Behaviours: ot_ctx.","ref":"ot_ctx_noop.html","title":"ot_ctx_noop","type":"extras"},{"doc":"clear/2get_current/2get_value/3get_value/4remove/3set_current/3set_value/4","ref":"ot_ctx_noop.html#function-index","title":"ot_ctx_noop - Function Index","type":"extras"},{"doc":"clear/2 clear(ContextManager::ot_ctx:context_manager(), Namespace::ot_ctx:namespace()) -&gt; ok get_current/2 get_current(ContextManager::ot_ctx:context_manager(), Namespace::ot_ctx:namespace()) -&gt; ot_ctx:ctx() get_value/3 get_value(ContextManager::ot_ctx:context_manager(), Namespace::ot_ctx:namespace(), Key::ot_ctx:key()) -&gt; ot_ctx:value() get_value/4 get_value(ContextManager::ot_ctx:context_manager(), Namespace::ot_ctx:namespace(), Key::ot_ctx:key(), Default::ot_ctx:value()) -&gt; ot_ctx:value() remove/3 remove(ContextManager::ot_ctx:context_manager(), Namespace::ot_ctx:namespace(), Key::ot_ctx:key()) -&gt; ok set_current/3 set_current(ContextManager::ot_ctx:context_manager(), Namespace::ot_ctx:namespace(), Ctx::ot_ctx:ctx()) -&gt; ok set_value/4 set_value(ContextManager::ot_ctx:context_manager(), Namespace::ot_ctx:namespace(), Key::ot_ctx:key(), Value::ot_ctx:value()) -&gt; ok","ref":"ot_ctx_noop.html#function-details","title":"ot_ctx_noop - Function Details","type":"extras"},{"doc":"Module ot_measure Function Index Function Details","ref":"ot_measure.html","title":"ot_measure","type":"extras"},{"doc":"measurement/2record/2record/4","ref":"ot_measure.html#function-index","title":"ot_measure - Function Index","type":"extras"},{"doc":"measurement/2 measurement(NameOrInstrument::ot_meter:bound_instrument() | ot_meter:name(), Number::number()) -&gt; {ot_meter:bound_instrument() | ot_meter:name(), number()} record/2 record(BoundInstrument::ot_meter:bound_instrument(), Number::number()) -&gt; ok record/4 record(Meter::opentelemetry:meter(), Name::ot_meter:name(), Number::number(), LabelSet::ot_meter:label_set()) -&gt; ok","ref":"ot_measure.html#function-details","title":"ot_measure - Function Details","type":"extras"},{"doc":"Module ot_meter Data Types Function Index Function Details This module defines the ot_meter behaviour. Required callback functions: new_instruments/2, record/3, record/4, record_batch/3, bind/3, release/2, register_observer/3, set_observer_callback/3, observe/3.","ref":"ot_meter.html","title":"ot_meter","type":"extras"},{"doc":"bound_instrument() bound_instrument() = {opentelemetry:meter(), term()} description() description() = unicode:unicode_binary() input_type() input_type() = integer | float instrument_kind() instrument_kind() = counter | observer | measure instrument_opts() instrument_opts() = \#{name =&gt; name(), description =&gt; description(), kind =&gt; instrument_kind(), type =&gt; input_type(), label_keys =&gt; [label_key()], unit =&gt; unit()} key() key() = {name(), label_set()} label_key() label_key() = unicode:unicode_binary() label_set() label_set() = [{label_key(), label_value()}] label_value() label_value() = unicode:unicode_binary() measurement() measurement() = {bound_instrument() | name(), number()} name() name() = unicode:unicode_binary() unit() unit() = atom()","ref":"ot_meter.html#data-types","title":"ot_meter - Data Types","type":"extras"},{"doc":"bind/3new_instruments/2observe/3record/2record/4record_batch/3register_observer/3release/1set_observer_callback/3","ref":"ot_meter.html#function-index","title":"ot_meter - Function Index","type":"extras"},{"doc":"bind/3 bind(Meter::opentelemetry:meter(), Name::name(), LabelSet::label_set()) -&gt; bound_instrument() new_instruments/2 new_instruments(Meter::opentelemetry:meter(), List::[instrument_opts()]) -&gt; boolean() observe/3 observe(X1::ot_observer:observer_result(), Number::number(), LabelSet::label_set()) -&gt; ok record/2 record(X1::bound_instrument(), Number::number()) -&gt; ok record/4 record(Meter::opentelemetry:meter(), Name::name(), Number::number(), LabelSet::label_set()) -&gt; ok record_batch/3 record_batch(Meter::opentelemetry:meter(), LabelSet::label_set(), Measurements::[measurement()]) -&gt; ok register_observer/3 register_observer(Meter::opentelemetry:meter(), Name::ot_meter:name(), Callback::ot_observer:callback()) -&gt; ok | unknown_instrument release/1 release(X1::bound_instrument()) -&gt; ok set_observer_callback/3 set_observer_callback(Meter::opentelemetry:meter(), Name::ot_meter:name(), Callback::ot_observer:callback()) -&gt; ok | unknown_instrument","ref":"ot_meter.html#function-details","title":"ot_meter - Function Details","type":"extras"},{"doc":"Module ot_meter_noop Function Index Function Details Behaviours: ot_meter.","ref":"ot_meter_noop.html","title":"ot_meter_noop","type":"extras"},{"doc":"bind/3labels/2new_instruments/2observe/3record/3record/4record_batch/3register_observer/3release/2set_observer_callback/3","ref":"ot_meter_noop.html#function-index","title":"ot_meter_noop - Function Index","type":"extras"},{"doc":"bind/3 bind(X1, X2, X3) -&gt; any() labels/2 labels(X1, X2) -&gt; any() new_instruments/2 new_instruments(X1, X2) -&gt; any() observe/3 observe(X1, X2, X3) -&gt; any() record/3 record(X1, X2, X3) -&gt; any() record/4 record(X1, X2, X3, X4) -&gt; any() record_batch/3 record_batch(X1, X2, X3) -&gt; any() register_observer/3 register_observer(X1, X2, X3) -&gt; any() release/2 release(X1, X2) -&gt; any() set_observer_callback/3 set_observer_callback(X1, X2, X3) -&gt; any()","ref":"ot_meter_noop.html#function-details","title":"ot_meter_noop - Function Details","type":"extras"},{"doc":"Module ot_meter_provider Function Index Function Details Behaviours: gen_server. This module defines the ot_meter_provider behaviour. Required callback functions: init/1, register_meter/3.","ref":"ot_meter_provider.html","title":"ot_meter_provider","type":"extras"},{"doc":"handle_call/3handle_cast/2init/1register_application_meter/1register_meter/2start_link/2","ref":"ot_meter_provider.html#function-index","title":"ot_meter_provider - Function Index","type":"extras"},{"doc":"handle_call/3 handle_call(Msg, From, State) -&gt; any() handle_cast/2 handle_cast(Msg, State) -&gt; any() init/1 init(X1) -&gt; any() register_application_meter/1 register_application_meter(Name::atom()) -&gt; boolean() register_meter/2 register_meter(Name::atom(), Vsn::string()) -&gt; boolean() start_link/2 start_link(ProviderModule, Opts) -&gt; any()","ref":"ot_meter_provider.html#function-details","title":"ot_meter_provider - Function Details","type":"extras"},{"doc":"Module ot_observer Description Data Types Function Index Function Details An Observer is a callback based instrument with a LastValue aggregator.","ref":"ot_observer.html","title":"ot_observer","type":"extras"},{"doc":"On each collection cycle each Observer callback is run and passed an ObserverInstrument variable to use when observeing the new value, passing the ObserverInstrument, the new value and a list of attributes, key/value pairs.","ref":"ot_observer.html#description","title":"ot_observer - Description","type":"extras"},{"doc":"callback() callback() = fun((observer_instrument()) -&gt; ok) observer_instrument() observer_instrument() = term()","ref":"ot_observer.html#data-types","title":"ot_observer - Data Types","type":"extras"},{"doc":"observe/3set_callback/3","ref":"ot_observer.html#function-index","title":"ot_observer - Function Index","type":"extras"},{"doc":"observe/3 observe(ObserverInstrument::observer_instrument(), Number::number(), LabelSet::ot_meter:label_set()) -&gt; ok set_callback/3 set_callback(Meter::opentelemetry:meter(), Observer::ot_meter:name(), Callback::callback()) -&gt; ok","ref":"ot_observer.html#function-details","title":"ot_observer - Function Details","type":"extras"},{"doc":"Module ot_propagation Data Types Function Index Function Details","ref":"ot_propagation.html","title":"ot_propagation","type":"extras"},{"doc":"extractor() extractor(T) = {fun((T, ot_ctx:context_manager(), ot_ctx:namespace(), {function(), term()}) -&gt; ok), term()} | {fun((T, ot_ctx:context_manager(), ot_ctx:namespace(), ot_ctx:key(), {function(), term()}) -&gt; ok), term()} http_extractor() http_extractor() = extractor(http_headers()) http_headers() http_headers() = [{iodata(), iodata()}] http_injector() http_injector() = injector(http_headers()) injector() injector(T) = {fun((T, ot_ctx:context_manager(), ot_ctx:namespace(), {function(), term()}) -&gt; T), term()} | {fun((T, ot_ctx:context_manager(), ot_ctx:namespace(), ot_ctx:key(), {function(), term()}) -&gt; T), term()}","ref":"ot_propagation.html#data-types","title":"ot_propagation - Data Types","type":"extras"},{"doc":"http_extract/1http_inject/1","ref":"ot_propagation.html#function-index","title":"ot_propagation - Function Index","type":"extras"},{"doc":"http_extract/1 http_extract(Headers) -&gt; any() http_inject/1 http_inject(Headers) -&gt; any()","ref":"ot_propagation.html#function-details","title":"ot_propagation - Function Details","type":"extras"},{"doc":"Module ot_span Description Data Types Function Index Function Details Span behaviour. This module defines the ot_span behaviour. Required callback functions: get_ctx/1, set_attribute/3, set_attributes/2, add_event/3, add_events/2, set_status/2, update_name/2.","ref":"ot_span.html","title":"ot_span","type":"extras"},{"doc":"start_opts() start_opts() = \#{parent =&gt; undefined | opentelemetry:span() | opentelemetry:span_ctx(), attributes =&gt; opentelemetry:attributes(), sampler =&gt; ot_sampler:sampler(), links =&gt; opentelemetry:links(), is_recording =&gt; boolean(), start_time =&gt; opentelemetry:timestamp(), kind =&gt; opentelemetry:span_kind()}","ref":"ot_span.html#data-types","title":"ot_span - Data Types","type":"extras"},{"doc":"add_event/4add_events/3get_ctx/2is_recording/2set_attribute/4set_attributes/3set_status/3update_name/3","ref":"ot_span.html#function-index","title":"ot_span - Function Index","type":"extras"},{"doc":"add_event/4 add_event(Tracer, SpanCtx, Name, Attributes) -&gt; boolean() Tracer = opentelemetry:tracer()Name = unicode:unicode_binary()Attributes = opentelemetry:attributes()SpanCtx = opentelemetry:span_ctx() add_events/3 add_events(Tracer, SpanCtx, Events) -&gt; boolean() Tracer = opentelemetry:tracer()Events = opentelemetry:events()SpanCtx = opentelemetry:span_ctx() get_ctx/2 get_ctx(Tracer, Span) -&gt; SpanCtx Tracer = opentelemetry:tracer()Span = opentelemetry:span()SpanCtx = opentelemetry:span_ctx() is_recording/2 is_recording(Tracer, SpanCtx) -&gt; boolean() Tracer = opentelemetry:tracer()SpanCtx = opentelemetry:span_ctx() set_attribute/4 set_attribute(Tracer, SpanCtx, Key, Value) -&gt; boolean() Tracer = opentelemetry:tracer()Key = opentelemetry:attribute_key()Value = opentelemetry:attribute_value()SpanCtx = opentelemetry:span_ctx() set_attributes/3 set_attributes(Tracer, SpanCtx, Attributes) -&gt; boolean() Tracer = opentelemetry:tracer()Attributes = opentelemetry:attributes()SpanCtx = opentelemetry:span_ctx() set_status/3 set_status(Tracer, SpanCtx, Status) -&gt; boolean() Tracer = opentelemetry:tracer()Status = opentelemetry:status()SpanCtx = opentelemetry:span_ctx() update_name/3 update_name(Tracer, SpanCtx, Name) -&gt; boolean() Tracer = opentelemetry:tracer()Name = opentelemetry:span_name()SpanCtx = opentelemetry:span_ctx()","ref":"ot_span.html#function-details","title":"ot_span - Function Details","type":"extras"},{"doc":"Module ot_tracer Data Types Function Index Function Details This module defines the ot_tracer behaviour. Required callback functions: start_span/3, create_span/3, set_span/2, with_span/3, with_span/4, end_span/1, end_span/2, current_ctx/1, current_span_ctx/1, span_module/1.","ref":"ot_tracer.html","title":"ot_tracer","type":"extras"},{"doc":"traced_fun() traced_fun(T) = fun((opentelemetry:span_ctx()) -&gt; T)","ref":"ot_tracer.html#data-types","title":"ot_tracer - Data Types","type":"extras"},{"doc":"create_span/3current_ctx/1current_span_ctx/1end_span/1end_span/2set_span/2span_module/1start_span/3with_span/3with_span/4","ref":"ot_tracer.html#function-index","title":"ot_tracer - Function Index","type":"extras"},{"doc":"create_span/3 create_span(Tracer::opentelemetry:tracer(), Name::opentelemetry:span_name(), Opts::ot_span:start_opts()) -&gt; opentelemetry:span_ctx() current_ctx/1 current_ctx(Tracer::opentelemetry:tracer()) -&gt; ot_tracer:tracer_ctx() current_span_ctx/1 current_span_ctx(Tracer::opentelemetry:tracer()) -&gt; opentelemetry:span_ctx() end_span/1 end_span(Tracer::opentelemetry:tracer()) -&gt; boolean() | {error, term()} end_span/2 end_span(Tracer::opentelemetry:tracer(), TracerCtx::ot_tracer:tracer_ctx()) -&gt; boolean() | {error, term()} set_span/2 set_span(Tracer::opentelemetry:tracer(), SpanCtx::opentelemetry:span_ctx()) -&gt; ok span_module/1 span_module(Tracer) -&gt; any() start_span/3 start_span(Tracer::opentelemetry:tracer(), Name::opentelemetry:span_name(), Opts::ot_span:start_opts()) -&gt; opentelemetry:span_ctx() with_span/3 with_span(Tracer::opentelemetry:tracer(), SpanName::opentelemetry:span_name(), Fun::traced_fun(T)) -&gt; T with_span/4 with_span(Tracer::opentelemetry:tracer(), SpanName::opentelemetry:span_name(), Opts::ot_span:start_opts(), Fun::traced_fun(T)) -&gt; T","ref":"ot_tracer.html#function-details","title":"ot_tracer - Function Details","type":"extras"},{"doc":"Module ot_tracer_noop Function Index Function Details Behaviours: ot_tracer.","ref":"ot_tracer_noop.html","title":"ot_tracer_noop","type":"extras"},{"doc":"create_span/3current_ctx/1current_span_ctx/1end_span/1end_span/2set_span/2span_module/1start_span/3with_span/3with_span/4","ref":"ot_tracer_noop.html#function-index","title":"ot_tracer_noop - Function Index","type":"extras"},{"doc":"create_span/3 create_span(X1::opentelemetry:tracer(), Name::opentelemetry:span_name(), Opts::ot_span:start_opts()) -&gt; opentelemetry:span_ctx() current_ctx/1 current_ctx(Tracer::opentelemetry:tracer()) -&gt; ot_tracer:tracer_ctx() current_span_ctx/1 current_span_ctx(X1::opentelemetry:tracer()) -&gt; opentelemetry:span_ctx() end_span/1 end_span(X1::opentelemetry:tracer()) -&gt; boolean() | {error, term()} end_span/2 end_span(X1::opentelemetry:tracer(), X2::ot_tracer:span_ctx()) -&gt; boolean() | {error, term()} set_span/2 set_span(X1::opentelemetry:tracer(), SpanCtx::opentelemetry:span_ctx()) -&gt; ok span_module/1 span_module(X1) -&gt; any() start_span/3 start_span(X1::opentelemetry:tracer(), Name::opentelemetry:span_name(), X3::ot_span:start_opts()) -&gt; opentelemetry:span_ctx() with_span/3 with_span(X1::opentelemetry:tracer(), SpanName::opentelemetry:span_name(), Fun::ot_tracer:traced_fun(T)) -&gt; T with_span/4 with_span(X1::opentelemetry:tracer(), SpanName::opentelemetry:span_name(), Opts::ot_span:start_opts(), Fun::ot_tracer:traced_fun(T)) -&gt; T","ref":"ot_tracer_noop.html#function-details","title":"ot_tracer_noop - Function Details","type":"extras"},{"doc":"Module ot_tracer_provider Function Index Function Details Behaviours: gen_server. This module defines the ot_tracer_provider behaviour. Required callback functions: init/1, register_tracer/3, resource/1.","ref":"ot_tracer_provider.html","title":"ot_tracer_provider","type":"extras"},{"doc":"code_change/3handle_call/3handle_cast/2init/1register_application_tracer/1register_tracer/2resource/0start_link/2","ref":"ot_tracer_provider.html#function-index","title":"ot_tracer_provider - Function Index","type":"extras"},{"doc":"code_change/3 code_change(OldVsn, State, Extra) -&gt; any() handle_call/3 handle_call(Msg, From, State) -&gt; any() handle_cast/2 handle_cast(Msg, State) -&gt; any() init/1 init(X1) -&gt; any() register_application_tracer/1 register_application_tracer(Name::atom()) -&gt; boolean() register_tracer/2 register_tracer(Name::atom(), Vsn::string()) -&gt; boolean() resource/0 resource() -&gt; term() | undefined start_link/2 start_link(ProviderModule, Opts) -&gt; any()","ref":"ot_tracer_provider.html#function-details","title":"ot_tracer_provider - Function Details","type":"extras"}]